Index: arch/ppc/Makefile.inc
===================================================================
--- arch/ppc/Makefile.inc	(revision 3902f8a4db97bf99c417daca9652e8f1f67bbac3)
+++ arch/ppc/Makefile.inc	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -1,6 +1,10 @@
+PPC_TARGET=ppc-linux-gnu
+
 PPC_CC_DIR=/usr/local/ppc/bin
-CC=$(PPC_CC_DIR)/ppc-linux-gnu-gcc
-AS=$(PPC_CC_DIR)/ppc-linux-gnu-as
-LD=$(PPC_CC_DIR)/ppc-linux-gnu-ld
+PPC_BINUTILS_DIR=/usr/local/ppc/bin
+
+CC=$(PPC_CC_DIR)/$(PPC_TARGET)-gcc
+AS=$(PPC_BINUTILS_DIR)/$(PPC_TARGET)-as
+LD=$(PPC_BINUTILS_DIR)/$(PPC_TARGET)-ld
 
 ASFLAGS=
@@ -15,3 +19,7 @@
 	arch/fpu_context.c \
 	arch/dummy.s \
-	arch/start.S
+	arch/start.S \
+	arch/asm.s \
+	arch/putchar.c \
+	arch/mm/frame.c \
+	arch/mm/page.c
Index: arch/ppc/_link.ld
===================================================================
--- arch/ppc/_link.ld	(revision 3902f8a4db97bf99c417daca9652e8f1f67bbac3)
+++ arch/ppc/_link.ld	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -15,4 +15,11 @@
 		*(K_TEXT_START)
 		*(.text);
+		*(.rodata);
+		*(.rodata.*);
+		*(.data);		/* initialized data */
+		*(.sdata);
+		*(.sbss);
+		*(.bss);		/* uninitialized static variables */	
+		*(COMMON); 		/* global variables */
 		ktext_end = .;
 
Index: arch/ppc/boot/Makefile
===================================================================
--- arch/ppc/boot/Makefile	(revision 3902f8a4db97bf99c417daca9652e8f1f67bbac3)
+++ arch/ppc/boot/Makefile	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -1,2 +1,5 @@
+PPC_BINUTILS_DIR=/usr/local/ppc/bin
+PPC_TARGET=ppc-linux-gnu
+
 .PHONY: nothing build
 
@@ -6,9 +9,9 @@
 	cp boot.bin ../../../src/load.bin
 
-AS=/usr/local/mips/bin/decstation-ultrix-as
-LD=/usr/local/mips/bin/decstation-ultrix-ld
+AS=$(PPC_BINUTILS_DIR)/$(PPC_TARGET)-as
+LD=$(PPC_BINUTILS_DIR)/$(PPC_TARGET)-ld
 
-ASFLAGS=-mips2 -EL
-LFLAGS=--oformat=binary -mips2 -EL -e start
+ASFLAGS=
+LFLAGS=--oformat=binary -e start
 
 boot.bin: boot.o
Index: arch/ppc/boot/boot.s
===================================================================
--- arch/ppc/boot/boot.s	(revision 3902f8a4db97bf99c417daca9652e8f1f67bbac3)
+++ arch/ppc/boot/boot.s	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -1,4 +1,4 @@
 #
-# Copyright (C) 2001-2004 Jakub Jermar
+# Copyright (C) 2005 Martin Decky
 # All rights reserved.
 #
@@ -29,7 +29,4 @@
 .text
 
-.set noreorder
-.set nomacro
-
 .global start
 start:
Index: arch/ppc/src/asm.s
===================================================================
--- arch/ppc/src/asm.s	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
+++ arch/ppc/src/asm.s	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -0,0 +1,34 @@
+#
+# Copyright (C) 2005 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+.text
+
+.global cpu_halt
+cpu_halt:
+	b cpu_halt
+ 
Index: arch/ppc/src/dummy.s
===================================================================
--- arch/ppc/src/dummy.s	(revision 3902f8a4db97bf99c417daca9652e8f1f67bbac3)
+++ arch/ppc/src/dummy.s	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -48,4 +48,5 @@
 .global arch_late_init
 .global calibrate_delay_loop
+.global asm_delay_loop
 .global dummy
 
Index: arch/ppc/src/mm/frame.c
===================================================================
--- arch/ppc/src/mm/frame.c	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
+++ arch/ppc/src/mm/frame.c	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -0,0 +1,34 @@
+/*
+ * Copyright (C) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <arch/mm/frame.h>
+#include <mm/frame.h>
+
+void frame_arch_init(void)
+{
+}
Index: arch/ppc/src/mm/page.c
===================================================================
--- arch/ppc/src/mm/page.c	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
+++ arch/ppc/src/mm/page.c	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -0,0 +1,39 @@
+/*
+ * Copyright (C) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <arch/types.h>
+#include <arch/mm/page.h>
+#include <arch/mm/frame.h>
+#include <mm/frame.h>
+#include <mm/page.h>
+
+pte_t *PTL0 = NULL;
+
+void page_arch_init(void)
+{
+}
Index: arch/ppc/src/putchar.c
===================================================================
--- arch/ppc/src/putchar.c	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
+++ arch/ppc/src/putchar.c	(revision efa9b73911d63d18968d4c5215c7b8adedbe4a4a)
@@ -0,0 +1,35 @@
+/*
+ * Copyright (C) 2005 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include <putchar.h>
+#include <arch/types.h>
+
+
+void putchar(const char ch)
+{
+}
